SOCKETPAIR(2)

NAME
socketpair - create a pair of connected sockets

SYNOPSIS
#include <sys/socket.h>
int
socketpair(int d, int type, int protocol, int sv[2]);

DESCRIPTION
The socketpair() call creates an unnamed pair of connected sockets in the specified domain d, of the specified type, and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv[0] and sv[1]. The two sockets are indistinguishable.

Any combination of the following flags may additionally be used in the type argument:

SOCK_CLOEXEC
    Set close-on-exec flag on both the new descriptors.
SOCK_NONBLOCK
    Set non-blocking I/O mode on both the new sockets.

RETURN VALUES

ERRORS
The call succeeds unless:

[EAFNOSUPPORT]
    The specified address family is not supported on this machine.

[EPROTONOSUPPORT]
    The specified protocol is not supported on this machine.

[EOPNOTSUPP]
    The specified protocol does not support creation of socket pairs.

[EPROTOTYPE]
    The combination of the specified protocol and type is not supported.

[EMFILE]
    The per-process descriptor table is full.

[ENFILE]
    The system file table is full.

[ENOBUFS]
    Insufficient resources were available in the system to perform the operation.

[EFAULT]
    The address sv does not specify a valid part of the process address space.

SEE ALSO
pipe(2), read(2), socket(2), write(2)

STANDARDS
The socketpair() function conforms to p1003.1-2008. The SOCK_CLOEXEC and SOCK_NONBLOCK flags are expected to conform to a future revision of that standard.

HISTORY
The socketpair() function call appeared in 4.2BSD. Support for the SOCK_CLOEXEC and SOCK_NONBLOCK flags appeared in OpenBSD 5.7.

BUGS
This call is currently implemented only for the LOCAL domain. Many operating systems only accept a protocol of AF_UNSPEC, so that should be used instead of AF_LOCAL for maximal portability.